"use strict";

const electron      = require("electron");
const app           = electron.app;
const BrowserWindow = electron.BrowserWindow;
const fs            = require("fs");
const path          = require("path");
const WIDTH         = 1280;
const HEIGHT        = 800;
const URL           = "https://s3-ap-northeast-1.amazonaws.com/sugimoto/hair-tech-conf/HAIR.html";
const WORKINGDIR    = "/Users/pc-0205-n2/github/resumify/shot-1453270287203";
const SKIPS         = [];
const END           = 13;

app.on("window-all-closed", function() {
    if ( process.platform !== "darwin" ) {
        app.quit();
    }
});

let mainWindow;

app.on("ready", function() {
    mainWindow = new BrowserWindow({
        width: WIDTH,
        height: HEIGHT
    });
    mainWindow.on("closed", function() {
        mainWindow = null;
    });
    openSlide(1, true);
});

function openSlide(pageNumber, isFirst) {
    if ( SKIPS.indexOf(pageNumber) !== -1 ) {
        openSlide(pageNumber + 1, false);
        return;
    }
    mainWindow.loadURL(URL + "#" + pageNumber);
    const webContents = mainWindow.webContents;
    webContents.executeJavaScript(
        "(function(c) { c && (c.style.display = 'none'); })(document.getElementById('control'));"
    );
    setTimeout(function() {
        console.log("Taking screenshot " + pageNumber + " of " + END + "...");
        mainWindow.capturePage({
            x:      0,
            y:      0,
            width:  WIDTH,
            height: HEIGHT
        }, function(image) {
            fs.writeFile(path.join(WORKINGDIR, "/shot" + pageNumber + ".png"), image.toPng(), function(err) {
                if ( err ) {
                    console.log("Failed to screen shot");
                } else if ( pageNumber === END ) {
                    console.log("Screenshot has taken!");
                    app.quit();
                } else {
                    openSlide(pageNumber + 1, false);
                }
            });
        });
    }, 3000);
}
